

#ifndef _DESKICON_HH
#define _DESKICON_HH

#include <qwidget.h>
#include <qlist.h>

class Icon ;
class Sfm ;
class QPopupMenu ;

class DeskIcon : public QWidget {

  Q_OBJECT ;
  
  Icon *icon ;
  QPoint pressPoint ;
  bool transient ;


protected:
  void paintEvent (QPaintEvent *) ;
  void focusInEvent (QFocusEvent *) ;
  void focusOutEvent (QFocusEvent *) ;
  
  void mousePressEvent (QMouseEvent *) ;
  void mouseMoveEvent (QMouseEvent *) ;
  void mouseDoubleClickEvent (QMouseEvent *) ;

  void set_shape () ;

  QPopupMenu *menu ;
  
  signals:
  void newDirWindow (const char *) ;

public:
  
  DeskIcon (Icon *, bool temp=true) ;
  DeskIcon (DeskIcon *, bool temp=true) ;
  Icon * get_icon() const {return icon ; } 

  //  static Sfm *theApp ; // kludge 
  
 public slots:
 void dragDropHighlight (WId, const QPoint &, const QList<DeskIcon> &) ;
  void drag_drop_happened (WId, const QPoint &, const QList<DeskIcon> &) ;
  void larger () ;
  void smaller () ;
  

} ;

#endif // _DESKICON_HH
